# ビルド
## 論点

o 現状：
  o Node: vm.runInContextで各ファイルを読み込み
    - ちゃんとモジュール化するのは大変そう(例：define_libfunc)
  o ブラウザ：productionはmakeで結合。
    developmentは各ファイルを順に読み込み

----

## 2017/03/12

### log 01:18

  o 困っていること：
    - Node上でエラーが出たときに、行番号がわからない

  o ES6 module vs module.export
    - と思ったけど現状のNode.jsで動かすならmodule.export一択なのか。


  - global.js みたいなファイルを作り、nilとかを定義
    - リリース時：
    - 開発時：


    (function(){

      var nil = BiwaScheme.nil, ...

    })();


  ## ゴール

  o Node.js
    - development: ファイル番号がでる
    - release: ファイル番号がでる(できれば) 
  o ブラウザ
    - development: 結合せず読み込める(requirejs?)
    - release: 1ファイルに結合できる(webpack?)

  ## 実装ステップ

  o Node.js
    o development:
      - 各ファイルをモジュールにする
    - release: パッケージ化がうまくいくか確認
  o ブラウザ
    - development: 結合せず読み込める(requirejs?)
    - release: 1ファイルに結合できる(webpack?)

## 2017/03/11

### ファイル一覧をデータにしたい 18:56

1. FILES.jsにする？
  - ejs内ではrequireができないっぽい
1. FILES.jsonにする？
  - ejs内ではrequireができないのでファイルを読み込むこともできない...

###  15:32

あとはnpm installしたとき動くことを確認しないといけないな。

readFileSyncって基準ディレクトリどこだろう？
=> カレントディレクトリだったので、__dirnameをつかうようにした

### Gruntfile.js 15:32

module.exports = function(grunt) {
  grunt.loadNpmTasks('grunt-contrib-watch');
  grunt.loadNpmTasks('grunt-contrib-concat');

  grunt.initConfig({
    pkg: grunt.file.readJSON('package.json'),

    concat: {
      options: {
        separator: ';\n',
        sourceMap: true,
        // Suppress diff for generated js file
        // see: https://github.com/github/linguist/blob/1b429ea46bbf0caecac2e1f55bd730a0f037b1eb/lib/linguist/generated.rb#L154
        banner: '// Generated by grunt task\n',
      },
      dist: {
        src: [
          'src/platforms/node/module_preamble.js',
          'src/version.js',
          'src/header.js',
          'src/system/class.js',
          'src/system/_writer.js',
          'src/system/_types.js',
          'src/system/error.js',
          'src/system/set.js',
          'src/system/values.js',
          'src/system/pair.js',
          'src/system/symbol.js',
          'src/system/char.js',
          'src/system/number.js',
          'src/system/port.js',
          'src/system/record.js',
          'src/system/enumeration.js',
          'src/system/hashtable.js',
          'src/system/syntax.js',
          'src/system/parser.js',
          'src/system/compiler.js',
          'src/system/pause.js',
          'src/system/call.js',
          'src/system/interpreter.js',
          'src/system/promise.js',
          'src/library/infra.js',
          'src/library/r6rs_lib.js',
          'src/library/js_interface.js',
          'src/library/extra_lib.js',
          'src/library/node_functions.js',
          'src/library/srfi.js',
          'src/platforms/node/module_postamble.js',
        ],
        dest: 'release/node_biwascheme.js',
      },
    },
  });

  grunt.registerTask('default', ['uglify']);
};

### Nodeでもスタックトレースに行番号が出るよう直した 15:31

    ## 状況

    1. モジュール化する？
      - 現在はBiwaScheme.*にいろんなものが入りすぎてるから、モジュール化すること自体が難しそう(define_libfuncとか)
    1. eval作戦
      1. vm.runInThisContextが使えないか？
        - BiwaScheme.Port.CustomInputがないというエラー
      1. vm.createContextで専用のcontextを作ってやればよい？
        - エラー時にスタックトレースが出ない??
        => 勘違いだったっぽい。
    1. 結合＋sourcemap作戦
      - 結合後、source-map-supportを使う
      1. rollup.jsを使う？
        - rollup src/*.jsしてみたら、一度に一つのファイルしかbundleできないと言われた
          (つまり中でちゃんとimportしないといけないのだろう)
      1. webpackを使う？
        - やり方がわからん...
      1. browserifyを使う？
      1. concatしてsourcemap作るだけのやつを探す？
        - https://github.com/floridoo/concat-with-sourcemaps
        - https://github.com/gruntjs/grunt-contrib-concat
          - 動いたっぽい

    o まとめ
      - vm.runInContextを使えば結合が不要
      - grunt + concat + sourcemapという構成も可能だが遅いのでいまのところ意味はない

### webpack + sourcemap 12:13

- http://qiita.com/pegass85/items/4bd80828f95ef13d6159
    devtool: 'inline-source-map'


### うーん 01:53

現在はBiwaScheme.*にいろんなものが入りすぎてるから、モジュール化すること自体が難しそうだ。

TODO: runInThisContext内で例外を投げてみてファイル名がでるかどうか試す。
出るならそれ使えばいいかも

## 2017/03/10

### log 23:32


## 2017/03/08

### 変数が漏れてる問題 16:24

o 要件
  - SymはBiwaScheme.Symと書きたくない
  - developmentでは漏れてもよい
    => 結合時に(function(){ })で囲めばよさそう

### console 16:01

node.jsからsyntaxの部分だけ実行とかしたいなあ。

make release/node_biwascheme.js && ./biwas foo.scm とかでいいかも？


