//
// Syntax
//
BiwaScheme.Syntax = BiwaScheme.Class.create({
  initialize: function (sname, func) {
    this.sname = sname;
    this.func = func;
  },
  transform: function (x) {
    if (!this.func) {
      throw new BiwaScheme.Bug("sorry, syntax " + this.sname + " is a pseudo syntax now");
    }
    return this.func(x);
  },
  inspect: function () {
    return "#<Syntax " + this.sname + ">";
  }
});

// A built-in syntax did not have associated Syntax object.
// Following code installed dummy Syntax objects to built-in syntax.
BiwaScheme.CoreEnv["define"] = new BiwaScheme.Syntax("define");
BiwaScheme.CoreEnv["begin"] = new BiwaScheme.Syntax("begin");
BiwaScheme.CoreEnv["quote"] = new BiwaScheme.Syntax("quote");
BiwaScheme.CoreEnv["lambda"] = new BiwaScheme.Syntax("lambda");
BiwaScheme.CoreEnv["if"] = new BiwaScheme.Syntax("if");
BiwaScheme.CoreEnv["set!"] = new BiwaScheme.Syntax("set!");